%###########################################################################
%# write_tptp.pl
%# - formatted output of clauses, rules and comments
%# - comments:	comment('bla bla').
%# - clauses:	clause( Name, Type, LitList, Cons, Dict ) 
%# - rules:	rule( Name, Type, LitList, Cons, Dict ) 
%###########################################################################
%# predicates to be used from outside:
%#	- printout_tptp/1
%#	- printout_tptp_list/1
%# dependent on
%#	- mylib.pl
%###########################################################################
%#        Max Moser                         Automated Reasoning Research Group
%# Email: moser@informatik.tu-muenchen.de     Lehrstuhl VIII f"ur Informatik
%# Tel.:  +49-89/521096			     Technische Universit"at M"unchen
%# Fax.:  +49-89/526502			         D-80290 M"unchen, Germany
%# http://wwwjessen.informatik.tu-muenchen.de/~moser
%###########################################################################


%*****************************************************************************
%* printout_tptp( +ClauseOrRuleOrComment )
%* printout_tptp_list( +ClauseOrRuleOrCommentList )
%*****************************************************************************
%* - print description, instantiate dictionary, and print clause or rule
%*****************************************************************************

printout_tptp( comment( Comment ) ) :-
	write( '% ' ), write( Comment ), writeln( "\n" ).

printout_tptp( nomodclause( Name, Type, LitList, Cons, Dict ) ) :-
	writeln( '% next clause: nomodclause' ),
	printout_tptp( clause( Name, Type, LitList, Cons, Dict ) ).

printout_tptp( nomodrule( Name, Type, LitList, Cons, Dict ) ) :-
	writeln( '% next clause: nomodrule' ),
	printout_tptp( clause( Name, Type, LitList, Cons, Dict ) ).

printout_tptp( rule( Name, Type, LitList, Cons, Dict ) ) :-
	writeln( '% next clause: rule' ),
	printout_tptp( clause( Name, Type, LitList, Cons, Dict ) ).

printout_tptp( clause( Name, Type, LitList, _, Dict ) ) :-
	inst_dict( Dict ),
	write( 'input_clause(' ),
	write( Name ),
	write( ',' ),
	write( Type ),
	write( ",\n    " ),
	printf( "%Dw", [LitList] ), nl,
	writeln( ").\n" ).


printout_tptp_list( [] ).

printout_tptp_list( [ClauseOrRule|Rest] ) :-
	on_verbose_report( '.', "" ),
	printout_tptp( ClauseOrRule ),
	printout_tptp_list( Rest ).

%*****************************************************************************
