%###########################################################################
%# mod_sorts.pl
%# ext_var:
%#          - checks whether a term is a variable X or a variable
%#            <op>(X,<sort>) including sort information (by using a sort
%#            operator <op>)
%# process_switch_sort:
%#          - asserts the sort operators
%###########################################################################
%###########################################################################
%#        Joachim Steinbach                Automated Reasoning Research Group
%# Email: steinbac@informatik.tu-muenchen.de   Lehrstuhl VIII f"ur Informatik
%# Tel.:  +49-89/289-27913		     Technische Universit"at M"unchen
%# Fax.:  +49-89/289-27902		            D-80290 M"unchen, Germany
%# http://wwwjessen.informatik.tu-muenchen.de/~steinbac
%###########################################################################

% integrated, 12.02.98, Joachim
ext_var( Lit ) :-
     var( Lit ),
     !.

ext_var( Lit ) :-
     Lit =.. [SOp,Fst,_],
     cmd_arg(sort,Sorts),
     member(SOp,Sorts),
     !,
     var( Fst ).

% integrated, 17.02.98, Joachim
process_switch_sort( ["-sort", T] ) :-
        retract( cmd_arg(sort,S) ),
        !,
	assert( cmd_arg(sort,[T|S]) ),
	write( '# *** option: sort(' ),
	write( T ),
	writeln( ')' ).

% integrated, 12.02.98, Joachim
process_switch_sort( ["-sort", S] ) :-
	assert( cmd_arg(sort,[S]) ),
	write( '# *** option: sort(' ),
	write( S ),
	writeln( ')' ).
